<?php
/**
* File: EditBlackList.Admin.class.php
* This is the Edit Personal Blacklist Module for the Geeklog SpamX Plug-in!
*
* Copyright (C) 2004 by the following authors:
*
* @ Author		Tom Willett		tomw@pigstye.net
*
* Licensed under GNU General Public License
*
*/

/**
* Personal Black List Editor
*
*/

require_once($_CONF['path'] . 'plugins/spamx/BaseAdmin.class.php');

class EditBlackList extends BaseAdmin {
	/**
	* Constructor
	* 
	*/
	function display(){
		global $_CONF, $HTTP_GET_VARS, $HTTP_POST_VARS, $_TABLES, $LANG_SX00;

		require_once $_CONF['path'] . 'plugins/spamx/rss.inc.php';
		require_once $_CONF['path'] . 'plugins/spamx/ArrayWriter.class.php';
		
		$blacklist = $_CONF['path_html'] . '/spamx/blacklist.php';
		
		require_once($blacklist);
		$action = SPAMX_applyFilter($HTTP_GET_VARS['action']);
		if (empty($action)) {
			$action = SPAMX_applyFilter($HTTP_POST_VARS['paction']);
		}

		$entry = SPAMX_applyFilter($HTTP_GET_VARS['entry']);
		if (empty($entry)) {
			$entry = SPAMX_applyFilter($HTTP_POST_VARS['pentry']);
		}

		if ($action == 'delete') {
			$tmp = array();
			foreach($SPAMX_BLACKLIST as $e) {
				if ($e <> $entry) {
					$tmp[]=$e;
				}
			}
			$SPAMX_BLACKLIST = $tmp;
			$action= 'save';
		} elseif ($action == $LANG_SX00['addentry']) {
			if ($entry != "") {
				$SPAMX_BLACKLIST[]=$entry;
				$action='save';
			}
		} elseif ($action == $LANG_SX00['addcen']) {
			$SPAMX_BLACKLIST=array_merge($SPAMX_BLACKLIST,$_CONF['censorlist']);
			$SPAMX_BLACKLIST=array_unique($SPAMX_BLACKLIST);
			$action='save';
		}
		
		if ($action == 'save') {
			$SPAMX_BLACKLIST = array_unique($SPAMX_BLACKLIST);
			$aw = new ArrayWriter($blacklist,'SPAMX_BLACKLIST',$SPAMX_BLACKLIST);
			$aw->writeArray();
			Spamx_rss($SPAMX_BLACKLIST);
		}
		$display = '<hr><p><b>';
		$display .= $LANG_SX00['pblack'];
		$display .= '</b></p><ul>';
		foreach ($SPAMX_BLACKLIST as $e) {
			$display .= '<li><a href="' . $_CONF['site_admin_url'] . '/plugins/spamx/index.php?command=EditBlackList&action=delete&entry=' . urlencode($e) . '">' . $e . '</a></li>';
		}
		$display .= '</ul><p>' . $LANG_SX00['e1'] . '</p>';
		$display .= '<p>' . $LANG_SX00['e2'] . '</p>';
		$display .= '<form method="post" action="' . $_CONF['site_admin_url'] . '/plugins/spamx/index.php?command=EditBlackList">';
		$display .= '<input type="text" size ="30" name="pentry">&nbsp;&nbsp;&nbsp;';
		$display .= '<input type="Submit" name="paction" value="' . $LANG_SX00['addentry'] . '">';
		$display .= '<p>' . $LANG_SX00['e3'] . '&nbsp&nbsp&nbsp';
		$display .= '<input type = "Submit" name="paction" value="' . $LANG_SX00['addcen'] . '">';
		$display .= '</form>';
		return $display;
	}
	
	function link()
	{
		return "Edit Personal Blacklist";
	}
}

?>