<?php
/**
* file:  Import.Admin.class.php
* MTBlacklist refresh module
*
* Updates Sites MT Blacklist via Master MT Blacklist rss feed
* 
* Copyright (C) 2004 by the following authors:
*
* @ Author		Tom Willett		tomw@pigstye.net
*
* Licensed under GNU General Public License
*
* Based on MT-Blacklist Updater by
* Cheah Chu Yeow (http://blog.codefront.net/)
*
*/

require_once($_CONF['path'] . 'plugins/spamx/BaseAdmin.class.php');


class Import extends BaseAdmin {
	/**
	* Constructor
	* 
	*/
	function display(){
		global $_CONF, $rss_url, $LANG_SX00;
		
		require_once($_CONF['path'] . 'plugins/spamx/magpierss/rss_fetch.inc');
		require_once($_CONF['path'] . 'plugins/spamx/magpierss/rss_utils.inc');
		require_once($_CONF['path'] . 'plugins/spamx/ArrayWriter.class.php');
		require_once($_CONF['path_html'] . '/spamx/mtblacklist.php');
		
		$rss = fetch_rss($rss_url);
		// entries to add and delete, according to the blacklist changes feed
		$to_add = array();
		$to_delete = array();

		foreach( $rss->items as $item ) {
			// time this entry was published (currently unused)
			//  $published_time = parse_w3cdtf( $item['dc']['date'] );

			$entry = substr( $item['description'], 0, -3 );  // blacklist entry
			$subject = $item['dc']['subject'];  // indicates addition or deletion

			// is this an addition or a deletion?
			if( strpos( $subject, 'addition' ) !== false ) {
				// save it for adding
				if (!in_array($entry, $MTBLACKLIST)) {
					$to_add[] = $entry;
				}
			} else if( strpos( $subject, 'deletion' ) !== false ) {
				// save it for deleting
				$to_delete[] = $entry;
			}
		}
		$MTBLACKLIST=array_merge($MTBLACKLIST,$to_add);
//		$MTBLACKLIST=array_diff($MTBLACKLIST,$to_delete);  array_diff bug
		foreach($to_delete as $entry) {
			$tmp = array();
			foreach($MTBLACKLIST as $e) {
				if ($e <> $entry) {
					$tmp[]=$e;
				}
			}
			$MTBLACKLIST = $tmp;
		}
		$MTBLACKLIST=array_unique($MTBLACKLIST);
		sort($MTBLACKLIST);
		$aw = new ArrayWriter($_CONF['path_html'] . '/spamx/' . 'mtblacklist.php','MTBLACKLIST',$MTBLACKLIST);
		$aw->WriteArray();
		$display = '<hr><p><b>' . $LANG_SX00['entriesadded'] . '</b></p><ul>';
		foreach ($to_add as $e) {
			$display .= "<li>$e</li>";
		}
		$display .= '</ul><p><b>' . $LANG_SX00['entriesdeleted'] . '</b></p><ul>';
		foreach ($to_delete as $e) {
			$display .= "<li>$e</li>";
		}
		$display .= '</ul>';
		SPAMX_log($LANG_SX00['uMTlist'] . $LANG_SX00['uMTlist2'] . count($to_add) . $LANG_SX00['uMTlist3'] . count($to_delete) . $LANG_SX00['entries']);
		return $display;
	}
	
	function link()
	{
		global $LANG_SX00;
		return $LANG_SX00['uMTlist'];
	}
}

?>